#include <bits/stdc++.h>

using namespace std;
int niz[200020], l[100010], r[100010], begg[200020], krajj[200020];
int grups[200020];

int main()
{
    int n;
    cin>>n;
    bool cheat=true;
    for(int i=1; i<=n; i++)
    {
        cin>>niz[i];
        if(niz[i]!=1 and niz[i]!=2)cheat=false;
    }
    int q; cin>>q;
    for(int i=0; i<q; i++)cin>>l[i]>>r[i];
    if(cheat)
    {
        for(int i=1; i<=n; i++)
        {
            begg[i]=begg[i-1]; krajj[i]=krajj[i-1];
            if(niz[i]==1)begg[i]++;
            else krajj[i]++;
            grups[i]=grups[i-1];
            if(niz[i]!=niz[i-1])grups[i]++;
        }
        for(int i=0; i<q; i++)
        {
            if(grups[r[i]]-grups[l[i]]+1>3)cout<<"NE\n";
            else if(grups[r[i]]-grups[l[i]]+1<=1)cout<<"DA\n";
            else if(grups[r[i]]-grups[l[i]]+1==2)
            {
                if(niz[l[i]]==1)cout<<"DA\n";
                else if(begg[r[i]]-begg[l[i]-1]>1 and krajj[r[i]]-krajj[l[i]-1]>1)cout<<"NE\n";
                else cout<<"DA\n";
            }
            else if(grups[r[i]]-grups[l[i]]+1==3)
            {
                if(begg[r[i]]-begg[l[i]-1]>1 and krajj[r[i]]-krajj[l[i]-1]>1)
                {
                    if(niz[l[i]]!=niz[l[i]+1] or niz[r[i]]!=niz[r[i]-1])cout<<"DA\n";
                    else cout<<"NE\n";
                }
                else cout<<"DA\n";
            }
        }
        return 0;
    }
    for(int i=2; i<=n; i++)
    {
        krajj[i]=krajj[i-1];
        begg[i-1]=begg[i-2];
        if(niz[i]<niz[i-1]){krajj[i]++; begg[i-1]++;}
    }
    begg[n]=begg[n-1];
    //for(int i=1; i<=n; i++)cout<<begg[i]<<" "<<krajj[i]<<"\n";
    for(int i=0; i<q; i++)
    {
        if(krajj[r[i]]-begg[l[i]-1]<=1)cout<<"DA\n";
        else cout<<"NE\n";
    }
    return 0;
}